
/*
 *
 * capture.h - part of Danovitsch Webcam
 *
 * Copyright (C) 2001 by Daan Vreeken
 *
 * Published under the terms of the GNU Public License 2.0
 * (or any later version)
 *
 */






extern int			Capture_Device;
extern int			Width;
extern int			Height;
extern unsigned char		*Frame;
extern unsigned char		*FrameBuffer;
extern struct timeval		FrameTime;
extern int			NewFrame;

extern int			Capture_Fifo[2];



enum Capture_SettingID
{
	NoID=0, ID_Brightness, ID_Hue, ID_CSaturation, ID_Contrast,
	ID_Input, ID_InputF, ID_Format, ID_Audio, ID_Channel, ID_ChannelType
};

enum Capture_SettingType
{
	NoType=0, Type_Number, Type_Text
};

enum Capture_SettingDevice
{
	NoDev=0, Dev_Bktr, Dev_Tuner
};

struct Capture_SettingsArr
{
	const enum Capture_SettingID		ID;
	const char				*Name;
	const enum Capture_SettingType		Type;
	const enum Capture_SettingDevice	Device;
	const int				MinVal;
	const int				MaxVal;
	int					NumValue;
	char					*OrgValue;
	char					*TxtValue;
};

extern struct Capture_SettingsArr	Capture_Settings[];


struct Capture_TextTable
{
	const enum Capture_SettingID	ID;
	const char	*Text;
	int		Value;
};

extern struct Capture_TextTable	Capture_SettingText[];


extern int Capture_LookupText(struct Capture_SettingsArr *Set, char *Text);
extern char *Capture_GetTextValue(char *Name);
extern int Capture_Set(struct Capture_SettingsArr *SetPtr, char *Name, int Value, char *Txt);
extern void Capture_SetFormat(void);
extern void Capture_SetSource(void);
extern void FrameDone_Handler(int Signal);
extern void Capture_Setup(void);
extern void Capture_Single();
extern void Capture_Shutdown();


